/*
 */
#ifndef FRAMECPP__FRAME_C_STREAM_INTERNAL_H
#define FRAMECPP__FRAME_C_STREAM_INTERNAL_H

#include "framecpp/IFrameStream.hh"
#include "framecpp/OFrameStream.hh"

struct fr_file
{
  union {
    FrameCPP::IFrameStream*	input;
    FrameCPP::OFrameStream*	output;
  } s_stream;
  
  fr_file_mode_t	s_mode;
};

namespace FrameC
{
  inline FrameCPP::IFrameStream*
  StreamAsInput( fr_file_t* Stream )
  {
    typedef FrameCPP::IFrameStream	stream_type;
    Validate( Stream );

    stream_type*			retval = (stream_type*)NULL;

    if ( Stream->s_mode == FRAMEC_FILE_MODE_INPUT )
    {
      retval = Stream->s_stream.input;
    }
    if ( retval == (stream_type*)NULL )
    {
      throw std::runtime_error( "The frame stream is not open for reading" );
    }
    return retval;
  }

  inline FrameCPP::OFrameStream*
  StreamAsOutput( fr_file_t* Stream )
  {
    typedef FrameCPP::OFrameStream	stream_type;

    Validate( Stream );

    stream_type*			retval = (stream_type*)NULL;

    if ( Stream->s_mode == FRAMEC_FILE_MODE_OUTPUT )
    {
      retval = Stream->s_stream.output;
    }
    if ( retval == (stream_type*)NULL )
    {
      throw std::runtime_error( "The frame stream is not open for writing" );
    }
    return retval;
  }
}

#endif /* FRAMECPP__FRAME_C_STREAM_INTERNAL_H */
