#ifndef GeneralTypesHH
#define GeneralTypesHH

/* Local Header Files  */
#include "general/config.h"

/* System Header Files */
#include <float.h>
#ifdef __cplusplus
#include <complex>
#endif /* __cplusplus */


#if SIZEOF_SHORT == 2
typedef short INT_2S;
typedef unsigned short INT_2U;
#elif SIZEOF_INT == 2
typedef int INT_2S;
typedef unsigned int INT_2U;
#else
#   error "No 2 byte integer found"
#endif

#if SIZEOF_INT == 4
typedef int INT_4S;
typedef unsigned int INT_4U;
#elif SIZEOF_LONG == 4
typedef long INT_4S;
typedef unsigned long INT_4U;
#else
#   error "No 4 byte integer found"
#endif

#if SIZEOF_LONG == 8
typedef long INT_8S;
typedef unsigned long INT_8U;
#elif SIZEOF_LONG_LONG == 8
typedef long long INT_8S;
typedef unsigned long long INT_8U;
#else
#   error "No 8 byte integer found"
#endif

#if SIZEOF_FLOAT == 4
typedef float REAL_4;
#define REAL_4_DIGITS FLT_DIG
#else
#   error "No 4 byte float found"
#endif

#if SIZEOF_DOUBLE == 8
typedef double REAL_8;
#define REAL_8_DIGITS DBL_DIG
#else
#   error "No 8 byte float found"
#endif

   
#ifdef __cplusplus
typedef std::complex< REAL_4 > COMPLEX_8;
typedef std::complex< REAL_8 > COMPLEX_16;
#else
/*------------------------------------------*/
/** \todo implement complex for C interface */
/*------------------------------------------*/
#endif /* __cplusplus */
   

typedef          char       CHAR;
typedef unsigned char       CHAR_U;


#if SIZEOF_VOIDP == 4
typedef INT_4U MEM_PTR;
#elif SIZEOF_VOIDP == 8
typedef INT_8U MEM_PTR;
#else
#   error "Unexpected sizeof(void*)"
#endif

   
#endif /* GeneralTypesHH */
